//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_chart_window

//
//
//
//
//

extern string AtrTimeFrame   = "Current time frame";
extern int    AtrPeriod      = 20;
extern double PercentToRisk  = 1.0;
extern color  TextColor      = Black;
extern int    TextSize       = 12;
extern int    TextCorner     = 3;

int timeFrame;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()   { timeFrame = stringToTimeFrame(AtrTimeFrame);        return(0); }
int deinit() { ObjectDelete("comment0"); ObjectDelete("comment1"); return(0); }
int start()
{
   double pipMultiplier = 1; if (Digits==3 || Digits==5) pipMultiplier = 10;
   
   //
   //
   //
   //
   //
      
   int LotDigit = 0;
      double atr       = iATR(NULL,timeFrame,AtrPeriod,0)/(Point*pipMultiplier);
      double TickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
      double Equity    = AccountEquity();
      double MinLots   = NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT) ,2);
      double MaxLots   = NormalizeDouble(MarketInfo(Symbol(),MODE_MAXLOT) ,2);
      double LotStep   = NormalizeDouble(MarketInfo(Symbol(),MODE_LOTSTEP),2);
            if (LotStep==1)    LotDigit=0;
            if (LotStep==0.1)  LotDigit=1;
            if (LotStep==0.01) LotDigit=2;
      double Lots = NormalizeDouble(((Equity*PercentToRisk)/100.0)/(atr*TickValue*pipMultiplier),LotDigit);
      
      //
      //
      //
      
      SetComment(0,15,"Risk : "+DoubleToStr(PercentToRisk,2)+"%, atr stop loss : "+DoubleToStr(atr,1)+" pips, lot size : "+DoubleToStr(Lots,LotDigit));
      if (Lots<MinLots)
            SetComment(1,30,"Lot size : "+DoubleToStr(Lots,LotDigit)+" smaller than minimum allowed lot size : "+DoubleToStr(MinLots,LotDigit));
      if (Lots>MaxLots)
            SetComment(1,30,"Lot size : "+DoubleToStr(Lots,LotDigit)+" greater than maximum allowed lot size : "+DoubleToStr(MaxLots,LotDigit));
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void SetComment(string add, int yPos, string value)
{
   string name = "comment"+add;
      ObjectCreate(name,OBJ_LABEL,0,0,0);
         ObjectSet(name,OBJPROP_CORNER,TextCorner);
         ObjectSet(name,OBJPROP_COLOR,TextColor);
         ObjectSet(name,OBJPROP_XDISTANCE,15);
         ObjectSet(name,OBJPROP_YDISTANCE,yPos);
         ObjectSetText(name,value,TextSize,"Arial bold");
         
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}